#! /bin/sh
arcs="
	ftp://sunsite.mff.cuni.cz/MIRRORS/sourceware.cygnus.com/pub/binutils/releases/binutils-2.9.1.tar.gz
	ftp://sunsite.mff.cuni.cz/MIRRORS/sourceware.cygnus.com/pub/gcc/releases/gcc-2.95.2/gcc-2.95.2.tar.bz2
	ftp://sunsite.mff.cuni.cz/MIRRORS/sourceware.cygnus.com/pub/newlib/newlib-1.8.2.tar.gz
	"
PREF="m68k-geoinvest-elf"
DEST="/usr/local/$PREF" #DEST="$HOME/$PREF"
export PATH="$PATH:$DEST/bin"
bnu=binutils-2.9.1
gcc=gcc-2.95.2
geo=geoinvest-gcc-2.95.2
lib=newlib-1.8.2
conf="--prefix=$DEST --program-prefix=$PREF- --nfp --target=$PREF --with-ld=$DEST/bin/$PREF-ld --with-as=$DEST/bin/$PREF-as --with-newlib=yes --enable-languages=c"
#--enable-languages=c,C

set -e

if [ "$1" = arcs ];then
	for i in $arcs;do
		c="lynx -source >`basename $i` $i"
		echo "$c"
		eval "$c"
		done
	exit
	fi

# Patching by $2 option not used now, originally used "geoinvest-gcc-2.8.1.patch"
function decomp
{
  if [ -z "$2" ];then echo -n "echo \"Decompressing $1...\";";f="$1.tar"
	else                echo -n "echo \"Patching from $1...\";";f="../$1.patch"
	  fi
	g="${f#../}"
		if [ -f "$g"     ];then echo -n "cat      <\"$f\""
	elif [ -f "$g.gz"  ];then echo -n "gzip  -d <\"$f.gz\""
	elif [ -f "$g.bz2" ];then echo -n "bzip2 -d <\"$f.bz2\""
	else echo >&2 "Can't find \"$g{,.gz,.bz2}\" file!";kill $$
	  fi
	if [ -z "$2" ];then echo "|tar xf -;if [ ! -e \"$1\" ];then echo >&2 \"Directory $1 doesn't exist!\";kill $$;fi"
	else                echo '|patch -sp1;if [ -n "`find -name "*.rej"`" ];then echo >&2 "Rejects exist, check!";kill $$;fi'
	  fi
}

function buildone
{
mkdir "$1-$PREF"
cd "$1-$PREF"
"../$1/configure" $conf $3 2>&1|tee errs1
if [ "$2" = cross ];then
	make cross 2>&1|tee errs2
	make install-cross 2>&1|tee errs3
else
	make 2>&1|tee errs2
	make install 2>&1|tee errs3
fi
cd ..
}

if [ "$1" != clean ];then
	gccd="`decomp "$gcc"`"
fi

bnud="`decomp "$bnu"`"
libd="`decomp "$lib"`"
geod="`decomp "$geo" patch`"

for i in "$bnu" "$gcc" "$lib";do
  if [ "$i" = "$bnu" -a "$1" = nbnu ];then continue;fi
	for j in "$i" "$i-$PREF";do
		if [ -e "$j" ];then
		echo "Cleaning up $j..."
		rm -rf "$j"
		fi
		done
	done

if [ "$1" = clean ];then exit 0;fi

if [ "$1" != nbnu ];then
	# binutils:
	###########
	eval "$bnud"
	buildone "$bnu" "" "--enable-targets=$PREF"
	fi

# gcc:
######
eval "$gccd"
#rm -rf "$gcc/gcc/{ch,f,java,objc,cp}"
(cd "$gcc"
 (cd "gcc/config/m68k"
  cp linux.h 68332.h
  cp t-m68kbare t-68332
 )
 ed Makefile.in <<HERE # ed-ed as it is more general than 'diff'
,s/c c++/c/g
,s/^\$(ALL_TARGET_MODULES):/\$(filter-out all-target-libiberty,\$(ALL_TARGET_MODULES)):/g
,s/^\$(CHECK_TARGET_MODULES):/\$(filter-out check-target-libiberty,\$(CHECK_TARGET_MODULES)):/g
,s/^\$(INSTALL_TARGET_MODULES):/\$(filter-out install-target-libiberty,\$(INSTALL_TARGET_MODULES)):/g
w
HERE
 eval "$geod"
 )
buildone "$gcc" cross

# newlib:
#########
eval "$libd"
buildone "$lib"

echo Done.
