#include "execkick.h"

#include "exec/resident.h"
#include "exec/nodes.h"
#include "exec/tasks.h"
#include "proto/exec.h"

#define STACKSIZE 0x1000

KICKTAG(resinit,"Test C-Resident #2","40.0 [Lace]",-122);

static struct Task *task[4];

static void taskfunc(void)
{
int i;

	i=AllocSignal(16);
	printd("Here I am!: $%08lx, signo=%ld\n",SysBase->ThisTask,i);
	for (;;) {
	  for (i=0;i<3;i++)
			if (task[i]==SysBase->ThisTask) break;
		printd("Task #%ld: %s\n",i,SysBase->ThisTask->tc_Node.ln_Name);
		i=(i+1)%3;
		Signal(task[i],0x10000);
		Wait(0x10000);
		}
}

static void print_node(struct Node *n)
{
	printd("Node(@$%08lx,type %lu,pri %ld \"%s\")",n,n->ln_Type,n->ln_Pri,n->ln_Name);
}

static void print_task(struct Task *t)
{
	printd("Task(");
	print_node(&t->tc_Node);
	printd(",sigAlloc=$%08lx)",t->tc_SigAlloc);
}

static void print_tasklist(struct List *l)
{
struct Task *n;
	for (n=(struct Task *)l->lh_Head;n->tc_Node.ln_Succ;n=(struct Task *)n->tc_Node.ln_Succ)
		{ print_task(n); printdnl(); }
}

static void tasklist(void)
{
	printd("TaskList (ThisTask=$%08lx)\n",SysBase->ThisTask);
	Forbid();
	printd("TaskReady list:\n");
	print_tasklist(&SysBase->TaskReady);
	printd("TaskList done.\n");
}

static void resinit(void)
{
	tasklist(); task[0]=CreateTask("Test2 task #0",-6,taskfunc,STACKSIZE);
	tasklist(); task[1]=CreateTask("Test2 task #1",-5,taskfunc,STACKSIZE);
	tasklist(); task[2]=CreateTask("Test2 task #2",-7,taskfunc,STACKSIZE);
	tasklist();

	printd("Wait() returned!: $%08lx\n",Wait(0));
}
